#include <stdio.h>

int clearFile(FILE *);
int dump(FILE *);
int printInventory(FILE *);
int addTool(FILE *);
int deleteTool(FILE *,int);
int updateTool(FILE *);

struct inventoryStruct {
	int toolID;
	char toolName[30];
	int toolInStock;
	float toolPrice;
};

main()
{

	FILE *inventoryFile;
	int choice = 0;
	
	if((inventoryFile = fopen("hardware.dat","r+")) == NULL) {
		printf("Error opening hardware.dat\n");
		exit(0);
	}

	printf("Welcome to Inventory Manager Version 0.01\n");
	printf("Please Choose a Function:\n");
	printf("1) Add Tool\n");
	printf("2) List Tools\n");
	printf("3) Delete Tool\n");
	printf("4) Update Tool\n");
	printf("5) Print This Message\n");
	printf("98) Dump of Tool Database\n");
	printf("99) Erase Tool Database\n");
	while(choice != -1) {
		printf("Please Enter a Function Number (-1 to quit, 5 to list): ");
		scanf("%d",&choice);
		switch (choice) {
			case -1: break;
			case 1: addTool(inventoryFile);
						break;
			case 2: printInventory(inventoryFile);
						break;
			case 3: deleteTool(inventoryFile, -1);
						break;
			case 4: updateTool(inventoryFile);
						break;
			case 5: 	printf("Please Choose a Function:\n");
						printf("1) Add Tool\n");
						printf("2) List Tools\n");
						printf("3) Delete Tool\n");
						printf("4) Update Tool\n");
						printf("5) Print This Message\n");
						printf("98) Dump of Tool Database\n");
						printf("99) Erase Tool Database\n");
						break;
			case 98: dump(inventoryFile);
						break;
			case 99: clearFile(inventoryFile);
						break;
			default: printf("%d is an invalid command\n",choice);
						break;
		}
	}

	printf("bye\n");

	fclose(inventoryFile);	
	
}


int updateTool(FILE *fp) {


} /* End updateTool */

int deleteTool(FILE *fp, int toolID) {

} /* End deleteTool */

int addTool(FILE *fp)
{

	struct inventoryStruct newTool, tempTool;
	fpos_t initialPosition;
	
	fgetpos(fp,&initialPosition);

	rewind(fp);
	
	printf("\nEnter new Tool ID: ");
	scanf("%d",&newTool.toolID);
	printf("Enter new Tool Name: ");
	getchar();
	fgets(newTool.toolName,sizeof(newTool.toolName) / sizeof(char), stdin);
	fflush(stdin);
	newTool.toolName[strlen(newTool.toolName) - 1] = '\0';
	printf("Enter number of %s in inventory: ",newTool.toolName);
	scanf("%d",&newTool.toolInStock);
	printf("Enter price of %s: ",newTool.toolName);
	scanf("%f",&newTool.toolPrice);
	
	while(fread(&tempTool,sizeof(struct inventoryStruct),1,fp) != EOF) {
		if(tempTool.toolID == newTool.toolID) {
			fseek(fp,-1 * (sizeof(struct inventoryStruct)),SEEK_CUR);
			fwrite(&newTool,sizeof(struct inventoryStruct),1,fp);
			printf("Added new tool %s\n",newTool.toolName);
			fsetpos(fp,&initialPosition);
			return 1;
		}
	}
	
	printf("Tool ID is invalid\n");
	fsetpos(fp,&initialPosition);
	return -1;
	
} /* end addTool */
	


int printInventory(FILE *fp)
{

	struct inventoryStruct item;
	fpos_t initialPosition;
	
	fgetpos(fp,&initialPosition);

	rewind(fp);

	printf("%-10s%-30s%-10s%8s\n","Record #","Tool Name","Quantity","Cost");

	while(fread(&item,sizeof(struct inventoryStruct),1,fp) > 0) 
		if(strcmp(item.toolName,""))
			printf("%-10d%-30s%-10d%8.2f\n",item.toolID,item.toolName,item.toolInStock,item.toolPrice);

	fsetpos(fp,&initialPosition);		

	return 1;


} /* end printInventory */

int dump(FILE *fp)
{

	struct inventoryStruct item;
	fpos_t initialPosition;
	
	fgetpos(fp,&initialPosition);

	rewind(fp);

	printf("%-10s%-20s%-10s%8s\n","Record #","Tool Name","Quantity","Cost");

	while(fread(&item,sizeof(struct inventoryStruct),1,fp) > 0) 
		printf("%-10d%-30s%-10d%8.2f\n",item.toolID,item.toolName,item.toolInStock,item.toolPrice);

	fsetpos(fp,&initialPosition);		

	return 1;
	
}	


int clearFile(FILE *fp)
{

	struct inventoryStruct item;
	int i;
	
	strcpy(item.toolName,"");
	item.toolInStock = -1;
	item.toolPrice = 0.0;
	
	for(i = 1; i <= 100; i++) {
		item.toolID = i;
		fwrite(&item, sizeof(struct inventoryStruct), 1, fp);
	}

	rewind(fp);
	
	return 1;
	
}
		
	