#include <stdio.h>


struct accountStruct {
	int accountNumber;
	char accountFirstName[21];
	char accountLastName[21];
	float accountBalance;
};

struct transactionStruct {
	int accountNumber;
	float transactionAmount;
};

#define TRUE 1
#define FALSE 0

int createAccount(char [], char [], float, FILE *);

int main()
{

	FILE *transFile,*oldFile,*newFile;
	struct accountStruct currentAccount,inAccount;
	struct transactionStruct currentTransaction;
	int goodTransaction = FALSE;

	if((transFile = fopen("trans.dat","r")) == NULL) {
		printf("error opening trans.dat\n");
		exit(-1);
	}
	
	if((oldFile = fopen("oldmast.dat","r+")) == NULL) {
		printf("Error opening oldmast.dat\n");
		exit(-1);
	}
	

	while(fscanf(transFile,"%d%f",&currentTransaction.accountNumber,&currentTransaction.transactionAmount) != EOF) {
		if((oldFile = fopen("oldmast.dat","r+")) == NULL) {
			printf("Error opening oldmast.dat\n");
			exit(-1);
		}
		if((newFile = fopen("newmast.dat","w")) == NULL) {
			printf("Error opening newmast.dat\n");
			exit(-1);
		}
		goodTransaction = FALSE;
		while(fscanf(oldFile,"%d%s%s%f",&inAccount.accountNumber,inAccount.accountFirstName,inAccount.accountLastName,&inAccount.accountBalance) != EOF) {
			if(inAccount.accountNumber == currentTransaction.accountNumber) {
				goodTransaction = TRUE;
				inAccount.accountBalance += currentTransaction.transactionAmount;
				fprintf(newFile,"%-4d%-20s%-20s%-8.2f\n",inAccount.accountNumber,inAccount.accountFirstName,inAccount.accountLastName,inAccount.accountBalance);
			} else
				fprintf(newFile,"%-4d%-20s%-20s%-8.2f\n",inAccount.accountNumber,inAccount.accountFirstName,inAccount.accountLastName,inAccount.accountBalance);
		}
		fclose(newFile);
		fclose(oldFile);
		rename("newmast.dat","oldmast.dat");
		if(!goodTransaction) {
			printf("Unmatched transaction record for account number %d\n",currentTransaction.accountNumber);
			printf("You may add this account if you wish\n");
		}
	}


	fclose(transFile);
	return(1);
	
} /* end main */		
	

int createAccount(char newAccountFirstName[], char newAccountLastName[], float newAccountBalance , FILE *fp)
{

	struct accountStruct newAccount, inAccount;
	
	strcpy(newAccount.accountFirstName,newAccountFirstName);
	strcpy(newAccount.accountLastName,newAccountLastName);
	newAccount.accountBalance = newAccountBalance;
	inAccount.accountNumber = 0;
	
	printf("here\n");
	
	while(fscanf(fp,"%d%s%s%f",&inAccount.accountNumber,inAccount.accountFirstName,inAccount.accountLastName,&inAccount.accountBalance) != EOF);

	fseek(fp,0L,SEEK_END);	
	newAccount.accountNumber = inAccount.accountNumber + 100;
	fprintf(fp,"%-4d%-20s%-20s%-8.2f\n",newAccount.accountNumber,newAccount.accountFirstName,newAccount.accountLastName,newAccount.accountBalance);
	rewind(fp);

	return(1);
	
}/* end createAccount */
		
	


	