#include <stdio.h>

struct stackNode {
	char data;
	struct stackNode *next;
};

typedef struct stackNode NODE;
typedef NODE *NODEPTR;

int push(NODEPTR *, char );
char pop(NODEPTR *);
void dump(NODEPTR);
int isEmpty(NODEPTR);
char stackTop(NODEPTR topPtr);
int precedence(char, char);
int isOperator(char c);
void convertToPostfix(char infix[], char postfix[]);

main()
{

	NODEPTR firstNode = NULL;
	char *string,*string2;
	char c;
	
	string = malloc(1024);
	string2 = malloc(1024);
	
	printf("please enter a string of text:");
	gets(string);
	printf("%s\n",string);
	convertToPostfix(string,string2);
		
}


void convertToPostfix(char infix[100], char postfix[100])
{

	NODEPTR stack = NULL;
	char *i,*p;

	push(&stack,'(');
	strcat(infix,")");

	i = infix;
	p = postfix;

	while((stack != NULL)) {
		if(isdigit(*i)) 
			*p++ = *i;
		else
		if( *i == '(' )
			push(&stack,*i);
		else
		if( isOperator(*i) ) {
			printf("found operator\n");
			if(isOperator(stackTop(stack)))
				while( precedence(stackTop(stack), *i) >= 0)
					*p++ = pop(&stack);
			push(&stack,*i);
		}
		else
		if( *i == ')' ) {
			printf("found ) \n");
			while( stackTop(stack) != '(' )
				*p++ = pop(&stack);
			pop(&stack);
		}
		
		i++;		
	}

	printf("%s\n",postfix);
	dump(stack);
	
}
	


int isEmpty(NODEPTR top)
{

	if(top == NULL)
		return 1;
	else
		return 0;
}

int isOperator(char c)
{

	if((c == '+') || (c == '-') || (c == '*') || (c == '/') || (c == '^') || (c == '%'))
		return 1;	
	else
		return 0;
}

int precedence(char operator1, char operator2)
{

	int op1, op2;
	
	switch(operator1) {
		case '+': op1 = 1;
			break;
		case '-': op1 = 1;
			break;
		case '*': op1 = 2;
			break;
		case '/': op1 = 2;
			break;
		case '%': op1 = 2;
			break;
		case '^': op1 = 3;
			break;
		default: 
			printf("%c is not an operator",operator1);
			return -9999;
	}
			

	switch(operator2) {
		case '+': op2 = 1;
			break;
		case '-': op2 = 1;
			break;
		case '*': op2 = 2;
			break;
		case '/': op2 = 2;
			break;
		case '%': op2 = 2;
			break;
		case '^': op2 = 3;
			break;
		default: 
			printf("%c is not an operator",operator1);
			return -9999;
	}
			
	return(op1 - op2);
	
}




char stackTop(NODEPTR topPtr)
{

	return (topPtr->data);
	
}

char pop(NODEPTR *topNode)
{

	NODEPTR deadNode,nextNode;
	char c;

	nextNode = *topNode;
	
	if(*topNode == NULL) {
		return(0);
	} else {
		deadNode = nextNode;
		*topNode = nextNode->next;
		c = deadNode->data;
		free(deadNode);
	}

	return c;

}

int push(NODEPTR *topNode, char data)
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	
	newNode->data = data;
	newNode->next = NULL;

	newNode->next = *topNode;
	*topNode = newNode;


}

void dump(NODEPTR topNode)
{

	if(topNode == NULL) {
		printf("Stack is empty\n");
	} else {
		while(topNode != NULL) {
			printf("%c\n",topNode->data);
			topNode = topNode->next;
		}
	}

}