#include <stdio.h>

struct stackNode {
	int data;
	struct stackNode *next;
};

typedef struct stackNode NODE;
typedef NODE *NODEPTR;

int push(NODEPTR *, int );
int pop(NODEPTR *);
void dump(NODEPTR);
int isEmpty(NODEPTR);
int stackTop(NODEPTR topPtr);
int precedence(char, char);
int isOperator(char c);
void convertToPostfix(char infix[], char postfix[]);
int calculate(int, int, char);
int evaluatePostfixExpression(char *expr);

main()
{

	NODEPTR firstNode = NULL;
	char *string,*string2;
	char c;

	string = malloc(1024);
	string2 = malloc(1024);
	
	printf("please enter a string of text:");
	gets(string);
	printf("%s\n",string);
	convertToPostfix(string,string2);

	printf("\n%s\n",string2);

	printf("Answer: %d\n",evaluatePostfixExpression(string2));

		
}

int evaluatePostfixExpression(char *expr)
{

	NODEPTR stack;
	char temp[10];
	int i;
	
	while(*expr != NULL) {
		i = 0;

		if(isdigit(*expr)) {
			while(isdigit(*expr))
				temp[i++] = *expr++;
			temp[i] = '\0';
			push(&stack,atoi(temp));
		}

		if(isOperator(*expr))
			push( &stack, ( calculate( pop(&stack),pop(&stack),*expr ) ) );	


		
		expr++;
	}

	return (pop(&stack));

}


int calculate(int op1, int op2, char operator)
{
	int pow = op1;

	switch(operator) {
		case '+': return (op1 + op2);
		case '-': return (op1 - op2);
		case '*': return (op1 * op2);
		case '/': return (op1 / op2);
		case '^': while(--op2 > 0) 
						op1 *= pow;
					return op1;
		case '%': return (op1 % op2);
		default: printf("ERROR: bad calculation\n");
				return -9999;
	}
	
} /*end calculate*/
	

void convertToPostfix(char infix[], char postfix[])
{

	NODEPTR stack = NULL;
	char *i,*p,n=0;
	char number[5];

	push(&stack,'(');
	strcat(infix,")");

	i = infix;
	p = postfix;

	while((stack != NULL)) {

		if(isdigit(*i)) {
			while(isdigit(*i))
				*p++ = *i++;
			*p++ = ' ';
		}


		if( *i == '(' )
			push(&stack,*i);

		if( isOperator(*i) ) {
			if(isOperator(stackTop(stack)))
				while( isOperator(stackTop(stack)) && (precedence(stackTop(stack), *i) >= 0)) {
					*p++ = pop(&stack);
					*p++ = ' ';
				}
			push(&stack,*i);
		}

		if( *i == ')' ) {
			while( stackTop(stack) != '(' ) {
				*p++ = pop(&stack);
				*p++ = ' ';
			}
			pop(&stack);
		}
		
		i++;		
	}

}
	


int isEmpty(NODEPTR top)
{

	if(top == NULL)
		return 1;
	else
		return 0;
}

int isOperator(char c)
{

	if((c == '+') || (c == '-') || (c == '*') || (c == '/') || (c == '^') || (c == '%') )
		return 1;	
	else
		return 0;
}

int precedence(char operator1, char operator2)
{

	int op1, op2;
	
	switch(operator1) {
		case '+': op1 = 1;
			break;
		case '-': op1 = 1;
			break;
		case '*': op1 = 2;
			break;
		case '/': op1 = 2;
			break;
		case '%': op1 = 2;
			break;
		case '^': op1 = 3;
			break;
		default: 
			printf("%c is not an operator",operator1);
			return -9999;
	}
			

	switch(operator2) {
		case '+': op2 = 1;
			break;
		case '-': op2 = 1;
			break;
		case '*': op2 = 2;
			break;
		case '/': op2 = 2;
			break;
		case '%': op2 = 2;
			break;
		case '^': op2 = 3;
			break;
		default: 
			printf("%c is not an operator",operator1);
			return -9999;
	}
			
	return(op1 - op2);
	
}




int stackTop(NODEPTR topPtr)
{

	return (topPtr->data);
	
}

int pop(NODEPTR *topNode)
{

	NODEPTR deadNode,nextNode;
	int c;

	nextNode = *topNode;
	
	if(*topNode == NULL) {
		return(0);
	} else {
		deadNode = nextNode;
		*topNode = nextNode->next;
		c = deadNode->data;
		free(deadNode);
	}

	return c;

}

int push(NODEPTR *topNode, int data)
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	
	newNode->data = data;
	newNode->next = NULL;

	newNode->next = *topNode;
	*topNode = newNode;


}

void dump(NODEPTR topNode)
{

	if(topNode == NULL) {
		printf("Stack is empty\n");
	} else {
		while(topNode != NULL) {
			printf("%c\n",topNode->data);
			topNode = topNode->next;
		}
	}

}