#include <stdio.h>
#include <stdlib.h>
#include <time.h>

struct queueNode {
	int wait;
	struct queueNode *next;
};

typedef struct queueNode NODE;
typedef NODE *NODEPTR;

int enqueue(NODEPTR *,NODEPTR *,int);
int dequeue(NODEPTR *, NODEPTR *);
void printqueue(NODEPTR);
void incrementWait(NODEPTR *);

int maxlinelength = 0;
int maxwait = 0;

main()
{

	NODEPTR head = NULL, tail = NULL;
	int i=0,s=0,day;
	int wait;

	head = tail;
	srand(time(NULL));

	i = rand() % 3 + 1;
	s = rand() % 5 + 1;
	
	for(day = 0; day < 720; day++){
		
		if(i == 0) {
			i = rand() % 3 + 1;
			enqueue(&head,&tail,0);
		}else i--;
		
		if(s == 0) {
			s = rand() % 5 + 1;
			wait = dequeue(&head,&tail);
			if(wait > maxwait)
				maxwait = wait;
		} else s--;

	printf("Line:");
	printqueue(head);
	printf("\n");	
	incrementWait(&head);
		
	}

	printf("\n\nMax Line Length: %d\n",maxlinelength);
	printf("Max Wait: %d\n",maxwait);
	
	
}

void incrementWait(NODEPTR *head)
{

	NODEPTR current;
	
	current = *head;
	
	while(current != NULL) {
		current->wait++;
		current = current->next;
	}

}

int dequeue(NODEPTR *head, NODEPTR *tail)
{

	NODEPTR deadNode;
	int wait;
	
	if(*head == NULL) {
		printf("Queue is empty\n");
		return '\0';
	}
	
	deadNode = *head;
	wait = deadNode->wait;
	*head = (*head)->next;
	free(deadNode);

	return wait;

}		

int enqueue(NODEPTR *head,NODEPTR *tail, int wait)
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	newNode->next = NULL;
	newNode->wait = wait;

	if(*head == NULL) {
		*head = newNode;
	} else {
		(*tail)->next = newNode;
	}

	*tail = newNode;
	
} /* end enqueue */
	

void printqueue(NODEPTR head)
{

	int i=0;

	if(head == NULL) {
		printf("Line is Empty");
	} else {
		while(head != NULL) {
			i++;
			printf("#");
			head = head->next;
		}
	printf("(%d)",i);
	}

	if(i > maxlinelength)
		maxlinelength = i;

	
} /* end printqueue */
