#include <stdio.h>

struct treeNode {
	int data;
	struct treeNode *leftPtr;
	struct treeNode *rightPtr;
};

typedef struct treeNode LEAFNODE;
typedef LEAFNODE *LEAFNODEPTR;

void insertNode(LEAFNODEPTR *, int);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
void inOrder(LEAFNODEPTR);
int depth(LEAFNODEPTR, int);

main()
{

	LEAFNODEPTR root = NULL;
	
	insertNode(&root, 47);
	insertNode(&root, 25);
	insertNode(&root, 11);
	insertNode(&root, 43);
	insertNode(&root, 7);
	insertNode(&root, 17);
	insertNode(&root, 31);
	insertNode(&root, 44);
	insertNode(&root, 77);
	insertNode(&root, 65);
	insertNode(&root, 93);
	insertNode(&root, 68);

	inOrder(root);

	printf("\nDepth is %d\n",depth(root,0));
	
}


int depth(LEAFNODEPTR root, int curdepth)
{

	int a=0,b=0;
	
	curdepth++;
	if((root->leftPtr == NULL) && (root->rightPtr == NULL) )
		return curdepth;
	else {
		if(root->leftPtr != NULL)
			a = depth(root->leftPtr, curdepth);
		if(root->rightPtr != NULL)
			b = depth(root->rightPtr, curdepth);
	}
	
	if(a > curdepth) 
		return a;
	else if(b > curdepth)
		return b;
	else
		return curdepth;	
	
}

void insertNode(LEAFNODEPTR *root, int data)
{

	if(*root == NULL) {
		*root = malloc(sizeof(LEAFNODE));
		
		if(*root != NULL) {
			(*root)->data = data;
			(*root)->leftPtr = NULL;
			(*root)->rightPtr = NULL;
		} else 
			printf("Memory not allocated - can't add leaf\n");
		
	} else 
		if(data < (*root)->data)
			insertNode(&((*root)->leftPtr), data);
		else
			if(data > (*root)->data)
				insertNode(&((*root)->rightPtr), data);
			else
				printf("duplicate\n");
	
} /*end insertNode*/

void inOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		printf("- %d -",root->data);
		inOrder(root->rightPtr);
	}
	
}