#include <stdio.h>

struct treeNode {
	int data;
	struct treeNode *leftPtr;
	struct treeNode *rightPtr;
};

typedef struct treeNode LEAFNODE;
typedef LEAFNODE *LEAFNODEPTR;

void insertNode(LEAFNODEPTR *, int);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
void inOrder(LEAFNODEPTR);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
LEAFNODEPTR findNode(LEAFNODEPTR *, int);
int deleteNode(LEAFNODEPTR *, int);

main()
{

	LEAFNODEPTR root = NULL;
	LEAFNODEPTR search = NULL;
	
	insertNode(&root, 47);
	insertNode(&root, 25);
	insertNode(&root, 11);
	insertNode(&root, 43);
	insertNode(&root, 7);
	insertNode(&root, 17);
	insertNode(&root, 31);
	insertNode(&root, 44);
	insertNode(&root, 77);
	insertNode(&root, 65);
	insertNode(&root, 93);
	insertNode(&root, 68);
	insertNode(&root, 78);
	insertNode(&root, 66);
	
	inOrder(root);
	printf("\n");
	preOrder(root);
	printf("\n");
	postOrder(root);
	printf("\n");

	deleteNode(&root, 47);

	printf("\n");
	inOrder(root);
	printf("\n");
	preOrder(root);
	printf("\n");
	postOrder(root);
	printf("\n");
	

}

int deleteNode(LEAFNODEPTR *root, int data)
{

	LEAFNODEPTR currentNode, newRoot;
	struct treeNode **side = NULL, **side2 = NULL;

	currentNode = *root;
	
	while(currentNode != NULL){
		if(currentNode->data == data) {
			printf("Found %d\n",currentNode->data);
			if((currentNode->leftPtr == NULL) && (currentNode->rightPtr == NULL)) {
				if(side != NULL)
					*side = NULL;
				else
					*root = NULL;
				free(currentNode);
				return 1;
			}
			if((currentNode->leftPtr == NULL) || (currentNode->rightPtr == NULL)) {
				if(side != NULL)
					*side = ((currentNode->leftPtr == NULL) ? currentNode->rightPtr : currentNode->leftPtr);
				else
					*root = ((currentNode->leftPtr == NULL) ? currentNode->rightPtr : currentNode->leftPtr);
				free(currentNode);
				return 1;	
			}
			if((currentNode->leftPtr != NULL) && (currentNode->rightPtr != NULL)) {
				newRoot = currentNode->leftPtr;
				side2 = &(currentNode->leftPtr);
				while(newRoot->rightPtr != NULL) {
					side2 = &(newRoot->rightPtr);
					newRoot = newRoot->rightPtr;
				}
				*side2 = newRoot->leftPtr;
				if(side != NULL)
					*side = newRoot;
				else
					*root = newRoot;
				newRoot->rightPtr = currentNode->rightPtr;
				newRoot->leftPtr = currentNode->leftPtr;
				free(currentNode);
				return 1;
			}
				
		}//end deleting part
		if(data < currentNode->data) {
			side = &(currentNode->leftPtr);
			currentNode = currentNode->leftPtr;
		}
		else
		if(data > currentNode->data) {
			side = &(currentNode->rightPtr);
			currentNode = currentNode->rightPtr;
		}	

		//end searching part
	} /* end loop */
		
	printf("Node not found, deletion incomplete\n");
	return 0;

} /*end deleteNode */


LEAFNODEPTR findNode(LEAFNODEPTR *root, int data)
{

	LEAFNODEPTR a;

	if(*root == NULL)
		return NULL;

	if((*root)->data == data) {
		return *root;
	}else {
		if(data < (*root)->data)
			a = findNode(&((*root)->leftPtr), data);
		else if(data > (*root)->data)
			a = findNode(&((*root)->rightPtr), data);
		if(a != NULL)
			return a;
	}

	return NULL;

}

void insertNode(LEAFNODEPTR *root, int data)
{

	if(*root == NULL) {
		*root = malloc(sizeof(LEAFNODE));
		
		if(*root != NULL) {
			(*root)->data = data;
			(*root)->leftPtr = NULL;
			(*root)->rightPtr = NULL;
		} else 
			printf("Memory not allocated - can't add leaf\n");
		
	} else 
		if(data < (*root)->data)
			insertNode(&((*root)->leftPtr), data);
		else
			if(data > (*root)->data)
				insertNode(&((*root)->rightPtr), data);
			else
				printf("duplicate\n");
	
} /*end insertNode*/

void inOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		printf("- %d -",root->data);
		inOrder(root->rightPtr);
	}
	
}

void preOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		printf("- %d -",root->data);
		inOrder(root->leftPtr);
		inOrder(root->rightPtr);
	}
	
}

void postOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		inOrder(root->rightPtr);
		printf("- %d -",root->data);
	}
	
}