#include <stdio.h>

struct treeNode {
	int data;
	struct treeNode *leftPtr;
	struct treeNode *rightPtr;
};

typedef struct treeNode LEAFNODE;
typedef LEAFNODE *LEAFNODEPTR;

struct queueNode {
	LEAFNODEPTR node;
	struct queueNode *next;
};

typedef struct queueNode NODE;
typedef NODE *NODEPTR;

int enqueue(NODEPTR *,NODEPTR *, LEAFNODEPTR);
LEAFNODEPTR dequeue(NODEPTR *, NODEPTR *);
void printqueue(NODEPTR);
void insertNode(LEAFNODEPTR *, int);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
void inOrder(LEAFNODEPTR);
void levelOrder(LEAFNODEPTR);

main()
{

	LEAFNODEPTR root = NULL;
	
	insertNode(&root, 27);
	insertNode(&root, 13);
	insertNode(&root, 6);
	insertNode(&root, 17);
	insertNode(&root, 42);
	insertNode(&root, 33);
	insertNode(&root, 48);
	
	inOrder(root);
	printf("\n");

	levelOrder(root);
	
}


void levelOrder(LEAFNODEPTR root)
{

	LEAFNODEPTR currentLeaf;
	NODEPTR currentNode, head = NULL, tail = NULL;
	int number;

	head = tail;
	
	currentLeaf = root;
	
	enqueue(&head, &tail, currentLeaf);
	
	while(head != NULL) {
		currentLeaf = dequeue(&head, &tail);
		printf("--%d--",currentLeaf->data);
		if(currentLeaf->leftPtr != NULL)
			enqueue(&head,&tail,currentLeaf->leftPtr);
		if(currentLeaf->rightPtr != NULL)
			enqueue(&head,&tail, currentLeaf->rightPtr);
	}


}

void insertNode(LEAFNODEPTR *root, int data)
{

	if(*root == NULL) {
		*root = malloc(sizeof(LEAFNODE));
		
		if(*root != NULL) {
			(*root)->data = data;
			(*root)->leftPtr = NULL;
			(*root)->rightPtr = NULL;
		} else 
			printf("Memory not allocated - can't add leaf\n");
		
	} else 
		if(data < (*root)->data)
			insertNode(&((*root)->leftPtr), data);
		else
			if(data > (*root)->data)
				insertNode(&((*root)->rightPtr), data);
			else
				printf("duplicate\n");
	
} /*end insertNode*/

void inOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		printf("- %d -",root->data);
		inOrder(root->rightPtr);
	}
	
}


LEAFNODEPTR dequeue(NODEPTR *head, NODEPTR *tail)
{

	NODEPTR deadNode;
	LEAFNODEPTR node;
	
	if(*head == NULL) {
		printf("Queue is empty\n");
		return 0;
	}
	
	deadNode = *head;
	node = deadNode->node;
	*head = (*head)->next;
	free(deadNode);
	
	return node;	

}		

int enqueue(NODEPTR *head,NODEPTR *tail, LEAFNODEPTR node)
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	newNode->node = node;
	newNode->next = NULL;

	if(*head == NULL) {
		*head = newNode;
	} else {
		(*tail)->next = newNode;
	}

	*tail = newNode;
	
} /* end enqueue */
	

void printqueue(NODEPTR head)
{

	if(head == NULL) {
		printf("Queue is empty\n");
	} else {
		while(head != NULL) {
			printf(">>%d<<", head->node->data);
			head = head->next;
		}
	}
	
} /* end printqueue */
