#include <stdio.h>

struct treeNode {
	int data;
	struct treeNode *leftPtr;
	struct treeNode *rightPtr;
};

typedef struct treeNode LEAFNODE;
typedef LEAFNODE *LEAFNODEPTR;

void insertNode(LEAFNODEPTR *, int);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
void inOrder(LEAFNODEPTR);
void printTree(LEAFNODEPTR, int totalSpaces);

main()
{

	LEAFNODEPTR root = NULL;
	
	insertNode(&root, 27);
	insertNode(&root, 13);
	insertNode(&root, 6);
	insertNode(&root, 17);
	insertNode(&root, 42);
	insertNode(&root, 33);
	insertNode(&root, 48);	
	inOrder(root);
	printf("\n");
	printTree(root, 0);
	
}

void printTree(LEAFNODEPTR root, int totalSpaces)
{
	
	int i;

	while(root != NULL) {
		printTree(root->rightPtr,totalSpaces+5);
		for(i = 0; i < totalSpaces; i++)
			printf(" ");
		printf("%d",root->data);
		root = root->leftPtr;
		totalSpaces += 5;
		printf("\n");
	}	

}

void insertNode(LEAFNODEPTR *root, int data)
{

	if(*root == NULL) {
		*root = malloc(sizeof(LEAFNODE));
		
		if(*root != NULL) {
			(*root)->data = data;
			(*root)->leftPtr = NULL;
			(*root)->rightPtr = NULL;
		} else 
			printf("Memory not allocated - can't add leaf\n");
		
	} else 
		if(data < (*root)->data)
			insertNode(&((*root)->leftPtr), data);
		else
			if(data > (*root)->data)
				insertNode(&((*root)->rightPtr), data);
			else
				printf("duplicate\n");
	
} /*end insertNode*/

void inOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		printf("- %d -",root->data);
		inOrder(root->rightPtr);
	}
	
}