#include <stdio.h>

struct listNode {
	int number;
	struct listNode *next;
};

typedef struct listNode NODE;
typedef NODE *NODEPTR;

int isEmpty(NODEPTR);
int addItem(NODEPTR *, int);
int nukeItem(NODEPTR *, int);
void printNodes(NODEPTR);
void concatenate(NODEPTR *, NODEPTR *);

main()
{

	NODEPTR listOne = NULL, listTwo = NULL;

	addItem(&listOne, 7);
	addItem(&listOne,6);

	addItem(&listTwo,9);
	addItem(&listTwo,3);
	addItem(&listTwo,0);

	printNodes(listOne);	
	printNodes(listTwo);

	concatenate(&listOne, &listTwo);
	
	printNodes(listOne);
	printNodes(listTwo);
	
} /* end main */


void concatenate(NODEPTR *dest, NODEPTR *source)
{

	NODEPTR current;

	current = *dest;
	
	while(current->next != NULL)
		current = current->next;

	current->next = *source;

}

int nukeItem(NODEPTR *first, int number)
{

	NODEPTR deadNode, currentNode, previousNode;
	
	currentNode = *first;
	previousNode = NULL;

	if(currentNode->number == number) {
		deadNode = currentNode;
		*first = currentNode->next;
		free(deadNode);
		printf("nuked %d\n",number);
		return 1;
	}
	
	while((currentNode != NULL) && (currentNode->number != number)) {
		previousNode = currentNode;
		currentNode = currentNode->next;
	}

	if(currentNode != NULL) {
		deadNode = currentNode;
		previousNode->next = currentNode->next;
		printf("moo\n");
		free(deadNode);
		return 1;
	} else {
		printf("number %d not found\n",number);
	}

	return (int)NULL;

}

int addItem(NODEPTR *first, int number)
{
	
	NODEPTR newNode, currentNode, previousNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	newNode->number = number;

	currentNode = *first;
	previousNode = NULL;
	
	while((currentNode != NULL) && (currentNode->number < newNode->number)) {
		previousNode = currentNode;
		currentNode = currentNode->next;
	}
	
	if(previousNode == NULL) {
		newNode->next = *first;
		*first = newNode;
	}else{
		previousNode->next = newNode;
		newNode->next = currentNode;
	}
	return 1;
	
}
	
void printNodes(NODEPTR currentNode)
{

	if(currentNode == NULL) {
		printf("List is empty\n");
	}else{
		printf("The List is:\n");
		
		while(currentNode != NULL) {
			printf(": %d :",currentNode->number);
			currentNode = currentNode->next;
		}
		
		printf("NULL\n\n");
	}
}
	

int isEmpty(NODEPTR firstNode)
{

	return (firstNode == NULL);
	
}