#include <stdio.h>

struct listNode {
	int number;
	struct listNode *next;
};

typedef struct listNode NODE;
typedef NODE *NODEPTR;

int isEmpty(NODEPTR);
int addItem(NODEPTR *, int);
int nukeItem(NODEPTR *, int);
void printNodes(NODEPTR);
void concatenate(NODEPTR *, NODEPTR *);
NODEPTR merge(NODEPTR, NODEPTR);

main()
{

	NODEPTR listOne = NULL, listTwo = NULL, new;

	addItem(&listOne, 7);
	addItem(&listOne,6);
	addItem(&listOne,12);
	addItem(&listOne,17);
	addItem(&listOne,-3);
	

	addItem(&listTwo,9);
	addItem(&listTwo,3);
	addItem(&listTwo,0);
	addItem(&listTwo,6);
	addItem(&listTwo,12);
	addItem(&listTwo,13);

	printNodes(listOne);	
	printNodes(listTwo);

	new = merge(listOne, listTwo);

	printf("merged\n");
	
	printNodes(listOne);
	printNodes(listTwo);
	printNodes(new);

	
} /* end main */


NODEPTR merge(NODEPTR one, NODEPTR two)
{

	NODEPTR cone, ctwo, newTop = NULL, current, next;

	if(one == NULL)
		return two;
	else
		if(two == NULL)
			return one;

	next = malloc(sizeof(NODE));

	if(one->number < two->number) {
		next->number = one->number;
		one = one->next;
	}else {
		next->number = two->number;
		two = two->next;
	}

	next->next = NULL;
	current = next;
	newTop = current;
		
	while((two != NULL) || (one != NULL)) {
		next = malloc(sizeof(NODE));
		printf("Doing\n");
		
		if(two == NULL){
				printf("used number %d from list one\n",one->number);
				next->number = one->number;
				one = one->next;
		}else
			if(one == NULL) {
				printf("used number %d from list two\n",two->number);
				next->number = two->number;
				two = two->next;
			}else 
				if (one->number < two->number) {
					next->number = one->number;
					one = one->next;
				} else {
						printf("used number %d from list two\n", two->number);
						next->number = two->number;
						two = two->next;
				}

	next->next = NULL;
	current->next = next;
	current = current->next;

	}

	return newTop;

}

void concatenate(NODEPTR *dest, NODEPTR *source)
{

	NODEPTR current;

	current = *dest;
	
	while(current->next != NULL)
		current = current->next;

	current->next = *source;

}

int nukeItem(NODEPTR *first, int number)
{

	NODEPTR deadNode, currentNode, previousNode;
	
	currentNode = *first;
	previousNode = NULL;

	if(currentNode->number == number) {
		deadNode = currentNode;
		*first = currentNode->next;
		free(deadNode);
		printf("nuked %d\n",number);
		return 1;
	}
	
	while((currentNode != NULL) && (currentNode->number != number)) {
		previousNode = currentNode;
		currentNode = currentNode->next;
	}

	if(currentNode != NULL) {
		deadNode = currentNode;
		previousNode->next = currentNode->next;
		printf("moo\n");
		free(deadNode);
		return 1;
	} else {
		printf("number %d not found\n",number);
	}

	return (int)NULL;

}

int addItem(NODEPTR *first, int number)
{
	
	NODEPTR newNode, currentNode, previousNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	newNode->number = number;

	currentNode = *first;
	previousNode = NULL;
	
	while((currentNode != NULL) && (currentNode->number < newNode->number)) {
		previousNode = currentNode;
		currentNode = currentNode->next;
	}
	
	if(previousNode == NULL) {
		newNode->next = *first;
		*first = newNode;
	}else{
		previousNode->next = newNode;
		newNode->next = currentNode;
	}
	return 1;
	
}
	
void printNodes(NODEPTR currentNode)
{

	if(currentNode == NULL) {
		printf("List is empty\n");
	}else{
		printf("The List is:\n");
		
		while(currentNode != NULL) {
			printf(": %d :",currentNode->number);
			currentNode = currentNode->next;
		}
		
		printf("NULL\n\n");
	}
}
	

int isEmpty(NODEPTR firstNode)
{

	return (firstNode == NULL);
	
}