#include <stdio.h>
#include <stdlib.h>

struct listNode {
	int number;
	struct listNode *next;
};

typedef struct listNode NODE;
typedef NODE *NODEPTR;

int isEmpty(NODEPTR);
int addItem(NODEPTR *, int);
int nukeItem(NODEPTR *, int);
void printNodes(NODEPTR);
void printStats(NODEPTR);
NODEPTR reverse(NODEPTR);

main()
{

	NODEPTR firstNode = NULL;
	NODEPTR reverseFirst = NULL;
	int i;

	srand(time(NULL));

	for(i = 0; i < 10; i++) {
		addItem(&firstNode,(rand() % 100));
	}

	reverseFirst = reverse(firstNode);

	printNodes(firstNode);	
	printNodes(reverseFirst);

	
} /* end main */


NODEPTR reverse(NODEPTR top)
{

	NODEPTR new, current, newTop;
	
	if(top == NULL) {
		printf("list is empty\n");
		return NULL;
	}

	current = NULL;

	printf("started\n");
	
	while(top != NULL) {
		new = malloc(sizeof(NODE));
		new->number = top->number;
		new->next = current;
		current = new;
		top = top->next;
	}

	printf("done\n");
	
	return current;
	
}		

void printStats(NODEPTR top)
{

	int i=0, total=0;
	float average=0.0;
	
	if(top == NULL) {
		printf("List is empty\n");
		return;
	}
	
	while(top != NULL) {
		i++;
		total += top->number;
		top = top->next;
	}
	
	printf("Sum of %d numbers is %d, average is %.2f\n",i,total,(float)total/i);
	
} /*end printStats*/

int nukeItem(NODEPTR *first, int number)
{

	NODEPTR deadNode, currentNode, previousNode;
	
	currentNode = *first;
	previousNode = NULL;

	if(currentNode->number == number) {
		deadNode = currentNode;
		*first = currentNode->next;
		free(deadNode);
		printf("nuked %d\n",number);
		return 1;
	}
	
	while((currentNode != NULL) && (currentNode->number != number)) {
		previousNode = currentNode;
		currentNode = currentNode->next;
	}

	if(currentNode != NULL) {
		deadNode = currentNode;
		previousNode->next = currentNode->next;
		printf("moo\n");
		free(deadNode);
		return 1;
	} else {
		printf("number %d not found\n",number);
	}

	return (int)NULL;

}

int addItem(NODEPTR *first, int number)
{
	
	NODEPTR newNode, currentNode, previousNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	newNode->number = number;

	currentNode = *first;
	previousNode = NULL;
	
	while((currentNode != NULL) && (currentNode->number < newNode->number)) {
		previousNode = currentNode;
		currentNode = currentNode->next;
	}
	
	if(previousNode == NULL) {
		newNode->next = *first;
		*first = newNode;
	}else{
		previousNode->next = newNode;
		newNode->next = currentNode;
	}
	return 1;
	
}
	
void printNodes(NODEPTR currentNode)
{

	if(currentNode == NULL) {
		printf("List is empty\n");
	}else{
		printf("The List is:\n");
		
		while(currentNode != NULL) {
			printf(": %d :",currentNode->number);
			currentNode = currentNode->next;
		}
		
		printf("NULL\n\n");
	}
}
	

int isEmpty(NODEPTR firstNode)
{

	return (firstNode == NULL);
	
}