#include <stdio.h>

void dump(int *, int *, int *, int *, int *, void (*)(void));
void fatalGeneric(void);
void fatalDivideBy0(void);
void fatalOverflow(void);
int checkBounds(int);

main()
{

	int memory[100];
	int accumulator = 0;
	int instructionCounter = 0;
	int operationCode = 0;
	int operand = 0;
	int instructionRegister = 0;
	int i = 0;

	printf("*** Welcome to Simpletron! ***\n");
	printf("\n*** Please enter your program one instruction ***\n");
	printf("*** (or data word) at a time. I will type the ***\n");
	printf("*** location number and a question mark (?).  ***\n");
	printf("*** You then type the word for that location  ***\n");
	printf("*** Type the sentinel -99999 to stop entering ***\n");
	printf("*** your program. ***\n");

	for(i = 0; i < 100 && memory[i-1] != -99999; i++) {
		printf("%2d ? ",i);
		scanf("%d",&memory[i]);
		if((checkBounds(memory[i]) < 0) && (memory[i] != -99999)) {
			printf("That is an invalid instruction - please reenter\n");
			i--;
		}	
	}
	memory[i-1] = 0;
	
	while(instructionCounter != -1) {
		instructionRegister = memory[instructionCounter];
		operationCode = instructionRegister / 100;
		operand = instructionRegister % 100;
		
		switch(operationCode) {
			case 10:
				scanf("%d",&memory[operand]);
				if(checkBounds(memory[operand]) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
				break;
			case 11:
				printf("%d",memory[operand]);
				break;
			case 20:
				accumulator = memory[operand];
				if(checkBounds(accumulator) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
				break;
			case 21:
				memory[operand] = accumulator;
				if(checkBounds(accumulator) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
				break;
			case 30:
				accumulator += memory[operand];
				if(checkBounds(accumulator) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
				break;
			case 31:
				accumulator -= memory[operand];
				if(checkBounds(accumulator) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
				break;
			case 32:
				if(memory[operand] == 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalDivideBy0);
					instructionCounter = -2;
					break;
				}	
				accumulator /= memory[operand];
				if(checkBounds(accumulator) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
					
				break;
			case 33:
				printf("multiplying\n");
				accumulator *= memory[operand];
				if(checkBounds(accumulator) < 0) {
					dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalOverflow);
					instructionCounter = -2;
					break;
				}
				break;
			case 40:
				instructionCounter = operand;
				instructionCounter--;
				break;
			case 41:
				if(accumulator < 0) {
					instructionCounter = operand;
					instructionCounter--;
				}
				break;
			case 42:
				if(accumulator == 0) {
					instructionCounter = operand;
					instructionCounter--;
				}
				break;
			case 43:
				dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,NULL);
				instructionCounter = -2;
				break;
			default:
				dump(&accumulator,&instructionCounter,&instructionRegister,&operationCode,&operand,fatalGeneric);
				instructionCounter = -2;
				break;
		}		
		instructionCounter++;
		
	}
}


int checkBounds(int number)
{

	if((number > 9999) || (number < -9999))
		return -1;
	return 1;
}

void dump(int *accumulator, int *instructionCounter, int *instructionRegister,int *operationCode, int *operand, 
		void (*errormessage)(void))
{

	if(*errormessage != NULL)
		(*errormessage)();

	printf("\n*** Simpletron execution terminated ***\n");
	printf("\nREGISTERS:\n");
	printf("%25s %4d\n","accumulator",*accumulator);
	printf("%25s %4d\n","instructionCounter",*instructionCounter);
	printf("%25s %4d\n","instructionRegister",*instructionRegister);
	printf("%25s %4d\n","operationCode",*operationCode);
	printf("%25s %4d\n","operand",*operand);
	
}

void fatalGeneric(void)
{

	printf("*** Fatal Error ***\n");
	printf("*** Simpletron execution abnormally terminated ***\n");

}

void fatalDivideBy0(void)
{

	printf("*** Fatal Error - Divide by 0 ***\n");
	printf("*** Simpletron execution abnormally terminated ***\n");

}

void fatalOverflow(void)
{

	printf("*** Fatal Error - Buffer Overflow  ***\n");
	printf("*** Simpletron execution abnormally terminated ***\n");
	
}